package altro.lockEvoluto_Sep17;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

public class LockEvoluto extends ReentrantLock 
{
	/**
	 * E' sufficiente una sola key poichè un Lock è in possesso da un solo thread per volta.
	 */
	String lockedKey;
	/**
	 * Si noti che lock e unlock sono sincronizzati per evitare race condition sull'accesso a key.
	 * @param key
	 */
	public synchronized void lock(String key)
	{
		lockedKey = key;
		lock();
	}
	public synchronized void unlock(String key) throws WrongUnlockKeyException
	{
		if (lockedKey.equals(key))
			unlock();
		else throw new WrongUnlockKeyException();
	}
	Condition newStepCondition()
	{
		return new StepCondition(this);
	}
	
}


